package epub;
################################################################
use File::Copy;
sub makes {
	local ($file, $title, $okut, $oku, $chosya, $giffd, $tagc, $zipfile) = @_;
	local (@lines, $pic, $hyoshi, $line, $kaunto, @linet, @linec, $count);
	&coa;
	&coc;
	copy "./epub/mimetype.dat","mimetype" || die $!;
	copy "$hyoshi","./OEBPS/Images/$pic" || die $!;
	copy "./epub/META-INF/container2.dat","./META-INF/container.xml" || die $!;
	copy "./epub/OEBPS/Styles/sgc-index.dat","./OEBPS/Styles/sgc-index.css" || die $!;

	$kaunto = "0";
	$count = "[2]  　2  　奥付  　$oku  　\n";
	push(@lines,$count);
	foreach $line (@lines) {
		if ($line =~  /^\[(.*)\]  　(.*)  　(.*)  　(.*)  　/) {
			$linec[$kaunto] = $4;
			$linet[$kaunto] = $3;
			$linec[$kaunto] =~ s/｜/<ruby><rb>/g;
			$linec[$kaunto] =~ s/《/<\/rb><rp>[<\/rp><rt>/g;
			$linec[$kaunto] =~ s/》/<\/rt><rp>]<\/rp><\/ruby>/g;
			$linec[$kaunto]  = "<p>$linec[$kaunto] ";
			$linec[$kaunto] =~ s/\r/<\/p>\r\n<p>/g;
			if ($linec[$kaunto] =~ /<p>$/) { $linec[$kaunto] = $`; }
			else { $linec[$kaunto] = "$linec[$kaunto]</p>\r\n"; }
			$linec[$kaunto] =~ s/<p/  <p/g;
			$linec[$kaunto] =~ s/<p><\/p>/<p>　<\/p>/g;
			$kaunto++;
		}
	}

##toc.ncx##

	$file = "toc2.dat"; &cob;
	local $ss = @linet;
	local $fn = 2001;
	local $nb = 2;
	$ss = $ss - 2;
	$file = "toc.ncx";

open(OUT,">./OEBPS/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【OKUT】/$okut/;
		$line =~ s/【TITLE】/$title/;
		$line =~ s/【NB】/$nb/g;
		if ($line =~ /【MAINE】/) {
			for ($count = 0; $count <= $ss; $count++) {
				print OUT "      <navPoint id=\"navPoint-$nb\" playOrder=\"$nb\">\r\n";
				print OUT "        <navLabel>\r\n";
				print OUT "          <text>$linet[$count]</text>\r\n";
				print OUT "        </navLabel>\r\n";
				print OUT "        <content src=\"Text/content$fn.xhtml\" />\r\n";
				print OUT "      </navPoint>\r\n";
				$fn++;
				$nb++;
			}
		}
		else { print OUT "$line"; }
	}
close(OUT);

##content.opf##

	local ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$mon++;
	if ($mon < 10) { $mon = "0$mon"; }
	if ($mday < 10) { $mday = "0$mday"; }
	$year = ($year + 1900);
	local $date = "$year-$mon-$mday";

	$file = "content.dat"; &cob;
	$fn = 2001;
	local $fn2 = 2001;
	$file = "content.opf";

open(OUT,">./OEBPS/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【TITLE】/$title/;
		$line =~ s/【著者】/$chosya/;
		$line =~ s/【画像】/$pic/;
		$line =~ s/【日時】/$date/;
		if ($line =~ /【MAINE】/) {
			for ($count = 0; $count <= $ss; $count++) {
				print OUT "    <item href=\"Text/content$fn.xhtml\" id=\"content$fn\" media-type=\"application/xhtml+xml\" />\r\n";
				$fn++;
			}
		}
		elsif ($line =~ /【MAINE2】/) {
			for ($count = 0; $count <= $ss; $count++) {
				print OUT "    <itemref idref=\"content$fn2\"  />\r\n";
				$fn2++;
			}
		}
		else { print OUT "$line"; }
	}
close(OUT);

##cover.xhtml##

	$file = "cover2.dat"; &cob;
	$file = "cover.xhtml";

open(OUT,">./OEBPS/Text/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【画像】/$pic/;
		print OUT "$line";
	}
close(OUT);

##titlepage.xhtml##

	$file = "titlepage2.dat"; &cob;
	$file = "titlepage.xhtml";

open(OUT,">./OEBPS/Text/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【TITLE】/$title/;
		$line =~ s/【著者】/$chosya/;
		print OUT "$line";
	}
close(OUT);

##notice.xhtml##

	$file = "notice2.dat"; &cob;
	$file = "notice.xhtml";
	$ss = @linet;
	$ss--;

open(OUT,">./OEBPS/Text/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【OKUT】/$okut/;
		$line =~ s/【TITLE】/$title/;
		if ($line =~ /【MAINE】/) {
			print OUT "$linec[$ss]";
		}
		else { print OUT "$line"; }
	}
close(OUT);

##content0000.xhtml##

	$file = "content2000.dat"; &cob;
	$ss--;
	$fn = 2001;

for ($count = 0; $count <= $ss; $count++) {
	$file = "content$fn.xhtml";

open(OUT,">./OEBPS/Text/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【TITLE】/$title/;		
		if ($line =~ /【TITLE2】/) {
			print OUT "  <h2>$linet[$count]</h2>\r\n";
		}
		elsif ($line =~ /【MAINE】/) {
			print OUT "$linec[$count]";
		}
		else { print OUT "$line"; }
	}
close(OUT);

	$fn++;
}

##ファイル圧縮##

	local @lists;
	opendir DIR,"./OEBPS/Text";
	local @lines = readdir DIR;
	foreach $kaunto (@lines) {
		if ($kaunto =~ /.xhtml$/) { push(@lists,"OEBPS/Text/$kaunto"); }
	}
	if (-e "./OEBPS/Styles/sgc-index.css") { push(@lists,"OEBPS/Styles/sgc-index.css"); }
	if (-e "./META-INF/container.xml") { push(@lists,"META-INF/container.xml"); }
	if (-e "./OEBPS/Images/$pic") { push(@lists,"OEBPS/Images/$pic"); }
	if (-e "./OEBPS/content.opf") { push(@lists,"OEBPS/content.opf"); }
	if (-e "./OEBPS/toc.ncx") { push(@lists,"OEBPS/toc.ncx"); }
	if (-e "mimetype") { push(@lists,"mimetype"); }

	&cod;

	return "$kaunto";
}
################################################################
sub make {
	local ($file, $title, $okut, $oku, $chosya, $giffd, $tagc, $zipfile) = @_;
	local (@lines, $pic, $hyoshi, $line, $kaunto, @linet, @linec, $count);
	&coa;
	&coc;
	copy "./epub/mimetype.dat","mimetype" || die $!;
	copy "$hyoshi","./OEBPS/Images/$pic" || die $!;
	copy "./epub/META-INF/com.apple.ibooks.display-options.dat","./META-INF/com.apple.ibooks.display-options.xml" || die $!;
	copy "./epub/META-INF/container.dat","./META-INF/container.xml" || die $!;
	copy "./epub/OEBPS/Styles/cover_horizontal.dat","./OEBPS/Styles/cover_horizontal.css" || die $!;
	copy "./epub/OEBPS/Styles/cover_vertical.dat","./OEBPS/Styles/cover_vertical.css" || die $!;
	copy "./epub/OEBPS/Styles/horizontal.dat","./OEBPS/Styles/horizontal.css" || die $!;
	copy "./epub/OEBPS/Styles/title_horizontal.dat","./OEBPS/Styles/title_horizontal.css" || die $!;
	copy "./epub/OEBPS/Styles/title_vertical.dat","./OEBPS/Styles/title_vertical.css" || die $!;
	copy "./epub/OEBPS/Styles/vertical.dat","./OEBPS/Styles/vertical.css" || die $!;

	$kaunto = "0";
	$count = "[2]  　2  　奥付  　$oku  　\n";
	push(@lines,$count);
	foreach $line (@lines) {
		if ($line =~  /^\[(.*)\]  　(.*)  　(.*)  　(.*)  　/) {
			$linec[$kaunto] = $4;
			$linet[$kaunto] = $3;
			$linec[$kaunto] =~ s/｜/<ruby><rb>/g;
			$linec[$kaunto] =~ s/《/<\/rb><rp>[<\/rp><rt>/g;
			$linec[$kaunto] =~ s/》/<\/rt><rp>]<\/rp><\/ruby>/g;
			if ($linec[$kaunto] =~ /^「/ || $linec[$kaunto] =~ /^（/) { $linec[$kaunto] = "<p class=\"dialog\">$linec[$kaunto] "; }
			else { $linec[$kaunto]  = "<p>$linec[$kaunto] "; }
			$linec[$kaunto] =~ s/\r/<\/p>\r\n<p>/g;
			$linec[$kaunto] =~ s/<p>「/<p class="dialog">「/g;
			$linec[$kaunto] =~ s/<p>（/<p class="dialog">（/g;
			if ($linec[$kaunto] =~ /<p>$/) { $linec[$kaunto] = $`; }
			else { $linec[$kaunto] = "$linec[$kaunto]</p>\r\n"; }
			$linec[$kaunto] =~ s/<p/      <p/g;
			$linec[$kaunto] =~ s/<p><\/p>/<p>　<\/p>/g;
			$kaunto++;
		}
	}

##toc.ncx##

	$file = "toc.dat"; &cob;
	local $ss = @linet;
	local $fn = 2001;
	local $nb = 4;
	$ss = $ss - 2;
	$file = "toc.ncx";

open(OUT,">./OEBPS/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【OKUT】/$okut/;
		$line =~ s/【TITLE】/$title/;
		$line =~ s/【NB】/$nb/;
		if ($line =~ /【MAINE】/) {
			for ($count = 0; $count <= $ss; $count++) {
				print OUT "        <navPoint id=\"content$fn\" playOrder=\"$nb\">\r\n";
				print OUT "            <navLabel>\r\n";
				print OUT "                <text>$linet[$count]</text>\r\n";
				print OUT "            </navLabel>\r\n";
				print OUT "            <content src=\"Text/content$fn.xhtml\"/>\r\n";
				print OUT "        </navPoint>\r\n";
				$fn++;
				$nb++;
			}
		}
		else { print OUT "$line"; }
	}
close(OUT);

##package.opf##

	local ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	if ($sec < 10) { $sec = "0$sec"; }
	if ($min < 10) { $min = "0$min"; }
	if ($hour < 10) { $hour = "0$hour"; }
	$mon++;
	if ($mon < 10) { $mon = "0$mon"; }
	if ($mday < 10) { $mday = "0$mday"; }
	$year = ($year + 1900);
	local $date = "$year-$mon-$mday\T$hour:$min:$sec\Z";

	$file = "package.dat"; &cob;
	$fn = 2001;
	local $fn2 = 2001;
	$file = "package.opf";

open(OUT,">./OEBPS/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【TITLE】/$title/;
		$line =~ s/【著者】/$chosya/;
		$line =~ s/【画像】/$pic/;
		$line =~ s/【日時】/$date/;
		if ($line =~ /【MAINE】/) {
			for ($count = 0; $count <= $ss; $count++) {
				print OUT "      <item id=\"c$fn\" href=\"Text/content$fn.xhtml\" media-type=\"application/xhtml+xml\" />\r\n";
				$fn++;
			}
		}
		elsif ($line =~ /【MAINE2】/) {
			for ($count = 0; $count <= $ss; $count++) {
				print OUT "    <itemref idref=\"c$fn2\" linear=\"yes\"/>\r\n";
				$fn2++;
			}
		}
		else { print OUT "$line"; }
	}
close(OUT);

##cover.xhtml##

	$file = "cover.dat"; &cob;
	$file = "cover.xhtml";

open(OUT,">./OEBPS/Text/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【TITLE】/$title/;
		$line =~ s/【著者】/$chosya/;
		$line =~ s/【画像】/$pic/;
		print OUT "$line";
	}
close(OUT);

##titlepage.xhtml##

	$file = "titlepage.dat"; &cob;
	$file = "titlepage.xhtml";

open(OUT,">./OEBPS/Text/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【TITLE】/$title/;
		$line =~ s/【著者】/$chosya/;
		print OUT "$line";
	}
close(OUT);

##navigation.xhtml##

	$file = "navigation.dat"; &cob;
	$file = "navigation.xhtml";
	$fn = 2001;
	local $toc = 1;

open(OUT,">./OEBPS/Text/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【OKUT】/$okut/;
		if ($line =~ /【MAINE】/) {
			for ($count = 0; $count <= $ss; $count++) {
				print OUT "          <li class=\"chapter\" id=\"toc-$toc\">\r\n";
				print OUT "            <a href=\"content$fn.xhtml\">$linet[$count]</a>\r\n";
				print OUT "          </li>\r\n";
				$fn++;
				$toc++;
			}
		}
		else { print OUT "$line"; }
	}
close(OUT);

##notice.xhtml##

	$file = "notice.dat"; &cob;
	$file = "notice.xhtml";
	$ss = @linet;
	$ss--;

open(OUT,">./OEBPS/Text/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【OKUT】/$okut/;
		$line =~ s/【TITLE】/$title/;
		if ($line =~ /【MAINE】/) {
			print OUT "$linec[$ss]";
		}
		else { print OUT "$line"; }
	}
close(OUT);

##content0000.xhtml##

	$file = "content0000.dat"; &cob;
	$ss--;
	$fn = 2001;

for ($count = 0; $count <= $ss; $count++) {
	$file = "content$fn.xhtml";

open(OUT,">./OEBPS/Text/$file") || die "Can't Open User Access Date: $!\n";
	foreach $line (@lines) {
		$line =~ s/【TITLE】/$title/;		
		if ($line =~ /【TITLE2】/) {
			print OUT "      <h2>$linet[$count]</h2>\r\n";
		}
		elsif ($line =~ /【MAINE】/) {
			print OUT "$linec[$count]";
		}
		else { print OUT "$line"; }
	}
close(OUT);

	$fn++;
}

##ファイル圧縮##

	local @lists;
	opendir DIR,"./OEBPS/Text";
	local @lines = readdir DIR;
	foreach $kaunto (@lines) {
		if ($kaunto =~ /.xhtml$/) { push(@lists,"OEBPS/Text/$kaunto"); }
	}
	opendir DIR,"./META-INF";
	local @lines = readdir DIR;
	foreach $kaunto (@lines) {
		if ($kaunto =~ /.xml$/) { push(@lists,"META-INF/$kaunto"); }
	}
	opendir DIR,"./OEBPS/Styles";
	local @lines = readdir DIR;
	foreach $kaunto (@lines) {
		if ($kaunto =~ /.css$/) { push(@lists,"OEBPS/Styles/$kaunto"); }
	}
	if (-e "./OEBPS/Images/$pic") { push(@lists,"OEBPS/Images/$pic"); }
	if (-e "./OEBPS/package.opf") { push(@lists,"OEBPS/package.opf"); }
	if (-e "./OEBPS/toc.ncx") { push(@lists,"OEBPS/toc.ncx"); }
	if (-e "mimetype") { push(@lists,"mimetype"); }

	&cod;

	return "$kaunto";
}
################################################################
sub coa {
	open(LOGD,"$file") || die "Can't Open User Access Log: $!\n";
	@lines=<LOGD>;
	close(LOGD);
}
sub cob {
	open(LOGD,"./epub/data/$file") || die "Can't Open User Access Log: $!\n";
	@lines=<LOGD>;
	close(LOGD);
}
sub coc {

##タグチェック##

	if (!$tagc) {
		foreach $line (@lines) { $line =~ s/<.*?>//g; }
	}

##ファイルを作る##

	if (-e "${giffd}book.jpg") { $hyoshi = "${giffd}book.jpg"; $pic = "book.jpg"; }
	elsif (-e "${giffd}book.png") { $hyoshi = "${giffd}book.png"; $pic = "book.png"; }
	else { $hyoshi = "./epub/data/book.jpg"; $pic = "book.jpg"; }
	mkdir "./META-INF";
	mkdir "./OEBPS";
	mkdir "./OEBPS/Images";
	mkdir "./OEBPS/Styles";
	mkdir "./OEBPS/Text";
}
sub cod {

##圧縮##

	require Archive::Zip;

	my $zip = Archive::Zip->new();
	foreach $kaunto (@lists){
		$zip->addFile("$kaunto");
	}
	$zipfile = "$giffd$zipfile\.epub";
	my $status = $zip->writeToFileNamed("$zipfile");

	if ($status != 'AZ_OK') {
		if (-e "$zipfile") { unlink("$zipfile") };
		$kaunto = "電子書籍の作成に失敗";
	}
	else { $kaunto = "<a href=\"$zipfile\">電子書籍ダウンロード</a>"; }

##ファイルを消す##

	unlink @lists;
	rmdir "./META-INF";
	rmdir "./OEBPS/Images";
	rmdir "./OEBPS/Styles";
	rmdir "./OEBPS/Text";
	rmdir "./OEBPS";
}
################################################################
1;
